#ifndef _BITMAP_H_
#define _BITMAP_H_

#include "Main.h"

#define BI_RLE4 0x00000002
#define BI_RLE8 0x00000001

typedef unsigned int uint;
typedef unsigned char uchar;
typedef unsigned short int WORD;
typedef unsigned long int DWORD;
typedef long int LONG;


/*
 ====================================================================
 ========================== FROM MICROSOFT ==========================
 ====================================================================
 */
typedef struct tagBITMAPFILEHEADER {
        WORD    bfType;
        int     bfSize;
        WORD    bfReserved1;
        WORD    bfReserved2;
        int     bfOffBits;
} BITMAPFILEHEADER;

typedef struct tagBITMAPINFOHEADER{
        int      biSize;
        int      biWidth;
        int      biHeight;
        WORD     biPlanes;
        WORD     biBitCount;
        int      biCompression;
        int      biSizeImage;
        int      biXPelsPerMeter;
        int      biYPelsPerMeter;
        int      biClrUsed;
        int      biClrImportant;
} BITMAPINFOHEADER;
/*=================================================================*/

typedef struct _BITMAPFILEHEADER {
    uint    bfType;
    DWORD   bfSize;
    uint    bfReserved1;
    uint    bfReserved2;
    DWORD   bfOffBits;
} mBITMAPFILEHEADER;

typedef struct _BITMAPINFOHEADER {   
    DWORD   biSize;
    LONG    biWidth;
    LONG    biHeight;
    WORD    biPlanes;
    WORD    biBitCount;
    DWORD   biCompression;
    DWORD   biSizeImage;
    LONG    biXPelsPerMeter;
    LONG    biYPelsPerMeter;
    DWORD   biClrUsed;
    DWORD   biClrImportant;
} mBITMAPINFOHEADER;


class CBmp{

public:
	CBmp(char* cpFileName);
	~CBmp();

	uint GetSizeOfBmp() const;
	uint GetHeight() const;
	uint GetWidth() const;
	uint GetBPP() const;
	uint GetColorPlane() const;
	uchar* GetBMP() const;
	unsigned long MakeRGB(uchar cR,uchar cG, uchar cB);
	void LoadFile(char* cpFileName);
	void WriteText(char* str);
	void SetGapiSurface(CGapiSurface* BackBuffer);
	void PutPixel( CGapiSurface* pBackBuffer, int x, int y, int r, int g, int b );
	void Display();

private:

	FILE* m_fpFile;
	uint m_DataSize;
	mBITMAPFILEHEADER m_hBitmap;
	mBITMAPINFOHEADER m_hBitmapInfo;
	uchar* m_cpData;
	CGapiSurface* m_pBackBuffer;
};

#endif